/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ifcoder.distribuicaonormal.classes;


import javax.swing.JFrame;
import javax.swing.JOptionPane;

/**
 *
 * @author jose
 */
public class FrDistribuicaoNormal extends JFrame {
    private ChartArea grafico;
    
    public final static String DIGITO = "[0-9]";
    public final static String DIGITOS = DIGITO + "+";
    public final static String LETRA = "[A-Za-z]";
    public final static String LETRAS = LETRA + "+";
    public final static String FRACAO = "((\\.|\\,)" + DIGITOS + "|)";
    public final static String EXPONENCIAL = "(E(\\+|-)?" + DIGITOS + "|)";
    public final static String REAL = "-?" + DIGITOS + FRACAO + EXPONENCIAL;
    
    
    /**
     * Creates new form DlgFuncao
     */
    public FrDistribuicaoNormal() {                 
        initComponents();
        grafico = new ChartArea(panGraficoFuncao);
    }        

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel10 = new javax.swing.JLabel();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        panGraficos = new javax.swing.JPanel();
        panGraficoFuncao = new javax.swing.JPanel();
        jPanel7 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        edtDe = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        edtAte = new javax.swing.JTextField();
        lblResultado = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        edtMedia = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        edtDesvio = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        edtPasso = new javax.swing.JTextField();

        jLabel10.setFont(new java.awt.Font("LM Sans 10", 1, 24)); // NOI18N
        jLabel10.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel10.setText("Distribuição normal");

        javax.swing.GroupLayout panGraficoFuncaoLayout = new javax.swing.GroupLayout(panGraficoFuncao);
        panGraficoFuncao.setLayout(panGraficoFuncaoLayout);
        panGraficoFuncaoLayout.setHorizontalGroup(
            panGraficoFuncaoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        panGraficoFuncaoLayout.setVerticalGroup(
            panGraficoFuncaoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 386, Short.MAX_VALUE)
        );

        jPanel7.setBorder(javax.swing.BorderFactory.createTitledBorder("Limites de integração"));

        jLabel2.setText("Inicio:");

        edtDe.setText("-10");
        edtDe.setToolTipText("");
        edtDe.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                edtDeActionPerformed(evt);
            }
        });

        jLabel3.setText("Fim:");

        edtAte.setText("30");
        edtAte.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                edtAteActionPerformed(evt);
            }
        });

        lblResultado.setText("Resultado:");

        jButton1.setText("Apply");
        jButton1.setContentAreaFilled(false);
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel7Layout = new javax.swing.GroupLayout(jPanel7);
        jPanel7.setLayout(jPanel7Layout);
        jPanel7Layout.setHorizontalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel7Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(edtDe, javax.swing.GroupLayout.PREFERRED_SIZE, 62, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel3)
                .addGap(4, 4, 4)
                .addComponent(edtAte, javax.swing.GroupLayout.PREFERRED_SIZE, 73, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(28, 28, 28)
                .addComponent(lblResultado, javax.swing.GroupLayout.PREFERRED_SIZE, 242, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 159, Short.MAX_VALUE)
                .addComponent(jButton1))
        );
        jPanel7Layout.setVerticalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel7Layout.createSequentialGroup()
                .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(edtDe, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel3)
                    .addComponent(edtAte, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(lblResultado, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jButton1))
                .addContainerGap())
        );

        javax.swing.GroupLayout panGraficosLayout = new javax.swing.GroupLayout(panGraficos);
        panGraficos.setLayout(panGraficosLayout);
        panGraficosLayout.setHorizontalGroup(
            panGraficosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(panGraficoFuncao, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPanel7, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        panGraficosLayout.setVerticalGroup(
            panGraficosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panGraficosLayout.createSequentialGroup()
                .addComponent(jPanel7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(panGraficoFuncao, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("Grafico", panGraficos);

        jLabel5.setText("Média:");

        edtMedia.setText("91.7");
        edtMedia.setToolTipText("");
        edtMedia.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                edtMediaActionPerformed(evt);
            }
        });

        jLabel6.setText("Desvio:");

        edtDesvio.setText("30.36");
        edtDesvio.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                edtDesvioActionPerformed(evt);
            }
        });

        jLabel4.setText("passo:");

        edtPasso.setText("1000");
        edtPasso.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                edtPassoActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addComponent(jLabel5)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(edtMedia, javax.swing.GroupLayout.PREFERRED_SIZE, 62, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel6)
                .addGap(4, 4, 4)
                .addComponent(edtDesvio, javax.swing.GroupLayout.PREFERRED_SIZE, 73, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jLabel4)
                .addGap(4, 4, 4)
                .addComponent(edtPasso, javax.swing.GroupLayout.PREFERRED_SIZE, 73, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                .addComponent(jLabel4)
                .addComponent(edtPasso, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                .addComponent(jLabel5)
                .addComponent(edtMedia, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addComponent(jLabel6)
                .addComponent(edtDesvio, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jLabel10, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPanel2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jTabbedPane1)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jLabel10)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTabbedPane1))
        );

        pack();
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void edtDeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_edtDeActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_edtDeActionPerformed

    private void edtAteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_edtAteActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_edtAteActionPerformed

    private void edtPassoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_edtPassoActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_edtPassoActionPerformed

    private void edtMediaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_edtMediaActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_edtMediaActionPerformed

    private void edtDesvioActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_edtDesvioActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_edtDesvioActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        if(edtDe.getText().isEmpty() || edtAte.getText().isEmpty()){
            JOptionPane.showMessageDialog(null, "Operação inválida. Limites de integração não definidos.");
        }else if(edtMedia.getText().isEmpty() || edtDesvio.getText().isEmpty()){
            JOptionPane.showMessageDialog(null, "Operação inválida. Falta dados da amostra(média/desvio).");
        }else{
           double media = string2Double(edtMedia.getText());
           double desvio = string2Double(edtDesvio.getText());
           double de = string2Double(edtDe.getText());
           double ate = string2Double(edtAte.getText());
           double qtdPassos = string2Double(edtPasso.getText());
           
           double area = grafico.preencheSerie(media, desvio, de, ate, (int) qtdPassos);           
           lblResultado.setText("Área: " + area);
        } 
    }//GEN-LAST:event_jButton1ActionPerformed
  
    public static double string2Double(String texto) {
        texto = texto.trim();
        if (confereExpressaoRegular(REAL, texto)) {
            texto = texto.replace(",", ".");
            return Double.parseDouble(texto);
        }
        return -1;
    }
    
    public static boolean confereExpressaoRegular(String exp, String texto) {
        if ((texto != null) && !texto.isEmpty()) {
            if (texto.matches(exp)) {
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField edtAte;
    private javax.swing.JTextField edtDe;
    private javax.swing.JTextField edtDesvio;
    private javax.swing.JTextField edtMedia;
    private javax.swing.JTextField edtPasso;
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JLabel lblResultado;
    private javax.swing.JPanel panGraficoFuncao;
    private javax.swing.JPanel panGraficos;
    // End of variables declaration//GEN-END:variables
}
